#include "mv167sup.h"
#include "vxWorks.h"
#include "gps.h"
#include "time.h"
#include "intLib.h"
#include "arch/mc68k/ivMc68k.h"

#define GPSBASE  0xffff0000

int first = 1;

void loopgps(int n1, int n2) {

     int i;
     void readgps();
     void nano();
    
     n2 *= 100000000;
     for (i = 0; i <= 10; i++) {
         readgps();
         nano(n1,n2);
     }

}

void initgps() {

     void vwr16();
     void readgps();

     sysIntEnable(INT_LEVEL);
     intLevelSet(INT_LEVEL);
     vwr16(GPSBASE + INT0_CONTROL, INT_ENABLE | INT_LEVEL);
     vwr16(GPSBASE + INT0_VECTOR, INT_VECTOR);
     intConnect(INUM_TO_IVEC(0xaa),readgps,0);
     vwr16(GPSBASE + GPS_CONFIG_REG_2, 0x0);
     vwr16(GPSBASE + GPS_CONFIG_REG_1, MASTER_IRQ_EN | EXT_GEN);

}

void readgps() {

     u_short dat_out, time_out[5];
     u_short         stat, days, hours, min;
     u_short         sec, msec, usec;
     u_short vrd16();

     if (first) {
        dat_out = vrd16(GPSBASE + GEN_TIME_REQ);
        time_out[0] = vrd16(GPSBASE + GEN_FREEZE1_WORD1);
        time_out[1] = vrd16(GPSBASE + GEN_FREEZE1_WORD2);
        time_out[2] = vrd16(GPSBASE + GEN_FREEZE1_WORD3);
        time_out[3] = vrd16(GPSBASE + GEN_FREEZE1_WORD4);
        time_out[4] = vrd16(GPSBASE + GEN_FREEZE1_WORD5);
        dat_out = vrd16(GPSBASE + GEN_FREEZE1_RELEASE);
        first = 0;
   
     }  else {

        time_out[0] = vrd16(GPSBASE + GEN_FREEZE2_WORD1);
        time_out[1] = vrd16(GPSBASE + GEN_FREEZE2_WORD2);
        time_out[2] = vrd16(GPSBASE + GEN_FREEZE2_WORD3);
        time_out[3] = vrd16(GPSBASE + GEN_FREEZE2_WORD4);
        time_out[4] = vrd16(GPSBASE + GEN_FREEZE2_WORD5);

     }
    
     dat_out = vrd16(GPSBASE + GEN_FREEZE2_RELEASE);

  stat   =  (time_out[3] >> 12) & 0x0f;             /* word 4 bits 12-15 */

  days   = ((time_out[3] >> 8 ) & 0x0f) * 100;      /* word 4 bits 08-11 */
  days  += ((time_out[3] >> 4 ) & 0x0f) * 10;       /* word 4 bits 04-07 */
  days  +=   time_out[3]        & 0x0f;             /* word 4 bits 00-03 */

  hours  = ((time_out[2] >> 12) & 0x0f) * 10;       /* word 3 bits 12-15 */
  hours +=  (time_out[2] >> 8 ) & 0x0f;             /* word 3 bits 08-11 */

  min    = ((time_out[2] >> 4 ) & 0x0f) * 10;       /* word 3 bits 04-07 */
  min   +=   time_out[2]        & 0x0f;             /* word 3 bits 00-03 */

  sec    = ((time_out[1] >> 12) & 0x0f) * 10;       /* word 2 bits 12-15 */
  sec   +=  (time_out[1] >> 8 ) & 0x0f;             /* word 2 bits 08-11 */

  msec   = ((time_out[1] >> 4 ) & 0x0f) * 100;      /* word 2 bits 04-07 */
  msec  +=  (time_out[1]        & 0x0f) * 10;       /* word 2 bits 00-03 */
  msec  +=  (time_out[0] >> 12) & 0x0f;             /* word 1 bits 12-15 */

  usec   = ((time_out[0] >> 8 ) & 0x0f) * 100;      /* word 1 bits 08-11 */
  usec  += ((time_out[0] >> 4 ) & 0x0f) * 10;       /* word 1 bits 04-07 */
  usec  +=   time_out[0]        & 0x0f;             /* word 1 bits 00-03 */

  logMsg("UTC: day %3d %02d:%02d:%02d.%06d\n ", days, hours, min,\
            sec, (msec*1000 + usec), 0);

}

u_short vrd16(u_short *addr) { 
        return(*addr);
}


void vwr16(u_short *addr, u_short value) {
     *addr = value;
}

void nano(int n1, int n2) {

     unsigned int t1,t2,tdiff;
     struct timespec mytime;

     mytime.tv_sec = n1;
     mytime.tv_nsec = n2;

     if (nanosleep(&mytime,NULL) == -1) printf("Error nanosleeping...\n");

}
