/****************************** Copyright Notice ******************************
 *                                                                            *
 * Copyright (c) 1991 Universities Research Association, Inc.                 *
 *               All Rights Reserved.                                         *
 *                                                                            *
 ******************************************************************************/
/* ==========================================================================
**
** DESCRIPTION
**	Function prototypes for mvNNNsup.c routines.
**
** DEVELOPERS
**      Dave Slimmer
**
** MODIFICATIONS - (please clutter this file with documention of modifications)
**	23dec93	das	entry
**      11jan94 das     added header file types.h for caddr_t def
**
**	13nov95 m.vittone   generalized the former mv167sup_prototypes.h
**			    to be sup_prototypes.h to support more boards
**			    and not to have harcoded board specific name.
*/

#ifndef INCsup_prototypesh
#define INCsup_prototypesh

#include <types.h>

int 		getKeyPress( void );
STATUS		gpioConnect( VOIDFUNCPTR routine, int arg );
void 		gpioInt( void );
void		gpioDisable( void );
void		gpioEnable( unsigned char mode );
void		gpioLevelSet (int level);
int		gpioStatus(void);
int		gpioMode(int mode);
int		gpioSet(int val);
int		gpioVStatus(void);
int		gpioV3Status(void);
int		gpioV1Status(void);
int		gpioV3Mode(int mode);
int		gpioV1Mode(int mode);
int		gpioVSet(int val);
int		gpioV3Set(int val);
int		gpioV1Set(int val);

STATUS 		clk1Connect( VOIDFUNCPTR routine, int arg );
void 		clk1Int (void);
void 		clk1Disable (void);
void 		clk1Enable (void);
void 		clk1LevelSet (int level);
int 		clk1RateGet (void);
int 		clk1uPeriodGet (void);
STATUS 		clk1RateSet (int ticksPerSecond);
STATUS 		clk1uPeriodSet (int uSeconds);
void 		clk1Start (void);
unsigned int 	clk1Stop (void);
STATUS 		clk2Connect( VOIDFUNCPTR routine, int arg);
void 		clk2Int (void);
void 		clk2Disable (void);
void 		clk2Enable (void);
void 		clk2LevelSet (int level);
int 		clk2RateGet (void);
int 		clk2uPeriodGet (void);
STATUS 		clk2RateSet (int ticksPerSecond);
STATUS 		clk2uPeriodSet (int uSeconds);
void 		clk2Start (void);
unsigned int 	clk2Stop (void);
int		spinDelay(  unsigned	usec
			  , int		intLock_flag );
STATUS 		LM0Connect( VOIDFUNCPTR routine, int arg );
void 		LM0Int (void);
void 		LM0Disable (void);
void 		LM0Enable (void);
void 		LM0LevelSet (int level);
STATUS 		LM1Connect( VOIDFUNCPTR routine, int arg );
void 		LM1Int (void);
void 		LM1Disable (void);
void 		LM1Enable (void);
void 		LM1LevelSet (int level);
STATUS 		LMCheck (int lm);
void 		LMAddressSet (unsigned short addr);
STATUS 		LMSIGAddressShow (void);
STATUS 		SIGConnect( int sig, VOIDFUNCPTR routine, int arg );
void 		SIGInt0 (void);
void 		SIGInt1 (void);
void 		SIGInt2 (void);
void 		SIGInt3 (void);
STATUS 		SIGDisable (int sig);
STATUS 		SIGEnable (int sig);
STATUS 		SIGLevelSet (int sig, int level);
STATUS 		SIGAddressSet (unsigned short addr);
STATUS 		mb (unsigned char *addr, unsigned char data, unsigned int special);
STATUS 		mw (unsigned short *addr, unsigned short data, unsigned int special);
STATUS 		ml (unsigned int *addr, unsigned int data, unsigned int special);
void 		vmeLock (void);
void 		vmeUnlock (void);
int 		vmeLocked (void);
void 		vmeSlaveMapShow (void);
void 		vmeMasterMapShow (void);
int		interruptShow (void);
void 		vmeSlaveMap1 (unsigned int am, unsigned int vmestart,
				unsigned int vmeend, unsigned int lbstart);
void 		vmeSlaveMap2 (unsigned int am, unsigned int vmestart,
				unsigned int vmeend, unsigned int lbstart);
int 		vmeSlaveMap1Am (unsigned int am);
int 		vmeSlaveMap2Am (unsigned int am);
void 		vmeSlaveMap1SnWp (int snoop_write_post);
void 		vmeSlaveMap2SnWp (int snoop_write_post);
void 		vmeMasterMap1 (unsigned int am, unsigned int vmestart,
				unsigned int vmeend, unsigned int width);
void 		vmeMasterMap2 (unsigned int am, unsigned int vmestart,
				unsigned int vmeend, unsigned int width);
void 		vmeMasterMap3 (unsigned int am, unsigned int vmestart,
				unsigned int vmeend, unsigned int width);
int		vmeMasterMap4 (unsigned int am, unsigned int vmestart,
				unsigned int vmeend, unsigned int lbstart,
				unsigned int width);
void 		vmeMasterIoMap2 (unsigned int am_mode);
void 		vmeMasterIoMap1 (unsigned int am_mode, unsigned int width);
void 		vmeMasterMap1Am (unsigned int am);
void 		vmeMasterMap2Am (unsigned int am);
void 		vmeMasterMap3Am (unsigned int am);
void 		vmeMasterMap4Am (unsigned int am);
void 		vmeMasterMap1Wp (int enable);
void 		vmeMasterMap2Wp (int enable);
void 		vmeMasterMap3Wp (int enable);
void 		vmeMasterMap4Wp (int enable);
void 		vmeBR (int level);
void 		dmaShow (void);
STATUS 		dmaConnect( VOIDFUNCPTR routine, int arg );
void 		dmaInt (void);
void 		dmaDisable (void);
void 		dmaEnable (void);
void 		dmaLevelSet (int level);
void 		dmaSn (int snoop_mode);
void 		dmaChainTblSn (int snoop_mode);
void		dmaChainTblInt( int int_flag );
STATUS 		dmaStart (caddr_t vmeadd, caddr_t localadd,
				unsigned int bytecnt, int dir, int dtb_mode,
				int non_blk_am);
int 		dmaStatus (void);
void 		dmaVmeBR( int level );
void 		dmaStartChain( struct dma_chain	*chain_addr );
struct dma_chain *dmaChainAlloc( int links );
struct dma_chain *dmaChainHead(  struct dma_chain	chain_a[]
			       , caddr_t		vmeadd
			       , caddr_t		localadd
			       , unsigned int		bytecnt
			       , int			dir
			       , int			dtb_mode
			       , int			non_blk_am );
int		dmaChainAdd(  struct dma_chain		chain_a[]
			    , caddr_t			vmeadd
			    , caddr_t			localadd
			    , unsigned int		bytecnt
			    , int			dir
			    , int			dtb_mode
			    , int			non_blk_am );
int 		dmaDone (void);
void 		dmaThrottle (int release_mode, int time_on, int time_off);
void 		cacheControlShow (void);
STATUS 		vmeIackedConnect( VOIDFUNCPTR routine, int arg );
void 		vmeIackedInt (void);
void 		vmeIackedDisable( void );
void 		vmeIackedEnable( void );
void 		vmeIackedLevelSet( int level );
int		vmeIntLevelSet( int irq, int cpu_level );
void  		tod_DateStr( char *s );
void 		tod_DateGet(  int *hour, int *mmin, int *sec, int *year
				    , int *month, int *ddate, int *day );
void 		Date( void );
void		tod_DateSet (int hour, int mmin, int sec, int year, 
				int month, int ddate, int day);
void 		dateSet (void);
STATUS 		addressTranslationShow (unsigned int start_addr,
					unsigned int end_addr,
					unsigned int show_mapping_mem);
unsigned	*addressTranslationLogToPhys( unsigned	*logical );
void		addressTranslationWritePhysical( unsigned *phys
						, unsigned	x );
unsigned	addressTranslationReadPhysical( unsigned *phys );
int 		addressTranslationRoot (unsigned int pagesize);
int 		ATCalloc (unsigned int elem_siz);
int 		addressTranslation (unsigned int log_start, 
					unsigned int log_end,
					unsigned int phys_start,
					unsigned int cache_mode,
					unsigned int write_prot,
					unsigned int expert);
unsigned int 	addressTranslationClear (unsigned int log_start,
					unsigned int log_end);
void 		addressTranslationDisable (void);
void 		addressTranslationDisablePaged (void);
int 		addressTranslationEnable (unsigned int dtt1base_override,
					unsigned int itt0cm,
					unsigned int itt1cm,
					unsigned int dtt0cm,
					unsigned int dtt1cm);
int 		addressTranslationEnablePaged (void);
int 		addressTranslationdtt0 (unsigned int base,
					unsigned int mask,
					unsigned int enable,
					unsigned int cm,
					unsigned int wp,
					unsigned int expert);
int 		addressTranslationTT (unsigned int TTreg,
					unsigned int base,
					unsigned int mask,
					unsigned int enable,
					unsigned int cm,
					unsigned int wp,
					unsigned int expert);
int 		addressTranslationSRPSet (unsigned int *srp);
void 		vmeSysReset (void);
void 		delayTaskPrioritySet (char *tname, int prio, int delay);

#endif /* INCsup_prototypesh */
