/************************************************************************/
/* File: timevw.h							*/
/*									*/
/* This is a modified version of time.h written to use specific		*/
/* Time-Of-Day devices that are implemented with the FSCC PC4 (DS1386),	*/
/* FSCC PC3 (DS1286), MVME167 MK48T08					*/
/*									*/

/*
SCCS release:
@(#) timevw.h 1.3 Delta: 93/06/01 16:59:05 Extraction: 93/06/10 15:22:41 @(#)
*/

#ifndef INCtimevw

#define INCtimevw

/************************************************************************/
/*									*/
/* Type Definitions and Structures					*/
/*									*/


#if !defined(_TYPES_) && !defined(__sys_types_h) && !defined(_TIME_T)
typedef long time_t;
#endif


struct tm {
	int	tm_sec;
	int	tm_min;
	int	tm_hour;
	int	tm_mday;
	int	tm_mon;
	int	tm_year;
	int	tm_wday;
	int	tm_yday;
	int	tm_isdst;
};

#ifdef __STDC__
extern time_t	time( time_t *tp );
extern char	*ctime( const time_t *timer );
extern char	*asctime( const struct tm *tmp );
extern struct tm	*gmtime( const time_t *timer );
extern struct tm	*localtime( const time_t *timer );
extern int	stime( long *tp );
extern time_t	mktime( struct tm *tp );
#else
extern time_t	time();
extern char	*ctime();
extern char	*asctime();
extern struct tm	*gmtime();
extern struct tm	*localtime();
extern int	stime();
extern time_t	mktime();
#endif

#if !__STD__

extern int	daylight;
extern long	timezone;
extern long	altzone;
extern char	*tzname[];

#endif

#endif /* INCtimevw */

/* file: timevw.h */
