/************************************************************************/
/* File: tod_prototypes.h						*/
/*									*/
/* Function prototypes for the Time-Of-Day routines implemented for the */
/* FSCC PC4 (DS1386),FSCC PC3 (DS1286), MVME167 MK48T08			*/
/*									*/

/*
SCCS release:
@(#) tod_prototypes.h 1.2 Delta: 93/12/22 11:37:16 Extraction: 94/01/11 09:41:52 @(#)
*/

#ifndef INCtod_prototypesh
#define INCtod_prototypesh

/************************************************************************/
/*									*/
/* tod_ Functions 							*/
/*									*/

extern INT32	tod_daysinmonth(INT32 year, INT32 month);
extern char 	*tod_asciiday(INT32 day);
extern char 	*tod_asciimonth(INT32 mo);
extern INT32	tod_julday( INT32 yr, INT32 mo, INT32 day );
extern INT32	tod_ep_days( int year, int yday );

/* tod_device.c functions */
extern	void    tod_device_id(void);
extern	void    tod_device_on(void);
extern	void    tod_device_off(void);
extern	time_t  tod_device_read( struct tm *tp );
extern	time_t  tod_read(void);
extern	void    tod_device_write( const struct tm *tp );
extern	void    tod_write(time_t timer);

/* tod_time.c functions */
extern	int     tod_initial(void);
extern	int     tod_show_tzrules(void);
extern	int     tod_get_tzrules(void);
extern	int     tod_set_tzrules(INT32 tz_hhmm, INT32 atz_hhmm,
                        	INT32 atzBegin_mmddhhmmd,
                        	INT32 atzEnd_mmddhhmmd,
                        	char *tz_name, char *atz_name);
extern	int     tod_setgmt(INT32 yymmdd, INT32 hhmmss);
extern	int     tod_setlocal(INT32 yymmdd, INT32 hhmmss);

/************************************************************************/
/* Time Functions							*/
/*									*/

extern	int	stime( long *tp );
extern	struct	tm * get_tm( const time_t timer, struct tm *tmp );
extern	int	settimeofday( struct timeval *tp, struct timezone *tzp );
extern	int	gettimeofday( struct timeval *tp, struct timezone *tzp );
extern	INT32	date( void );

#ifndef __INCtimeh
extern  char	*asctime( const struct tm *tmp );
extern	char	*ctime( const time_t *timer );
extern	struct	tm	*gmtime( const time_t *timer );
extern	struct	tm	*localtime( const time_t *timer );
extern	time_t	mktime( struct tm *tp );
extern	time_t	time( time_t *tp );
#endif /*__INCtimeh*/

#endif /* INCtod_prototypesh */

/* file: tod_prototypes.h */
