/************************************************************************/
/* File: tod_time.h							*/
/*									*/
/* This is a modified version of time.h written to use specific		*/
/* Time-Of-Day devices that are implemented with the FSCC PC4 (DS1386),	*/
/* FSCC PC3 (DS1286), MVME167 MK48T08					*/
/*									*/

/*
SCCS release:
@(#) tod_time.h 1.2 Delta: 93/12/22 11:37:28 Extraction: 94/01/11 09:41:48 @(#)
*/

#ifndef INCtod_time
#define INCtod_time

/************************************************************************/
/*									*/
/* Definitions to support the Time-Of-Day functions			*/
/*									*/

#define TOD_SECS_PER_DAY	86400L		/* Seconds per day */
#define TOD_USECS_PER_SEC	1000000L	/* uSeconds pre second */

#define TOD_ASCTM_SIZE	30			/* ascii string buffer */
#define TOD_YEAR0	70		/* Unix Epoch year (1970) */
#define TOD_DAY0	4		/* 1-Jan-1970 was a Thursday */


#ifdef VXWORKS
#include <sys/times.h>
#else
#ifndef __INCtimesh				/* VxWorks sys/times.h */
#if !defined(_sys_time_h) && !defined(__time_h)	/* system time files */
/************************************************************************/
/*									*/
/* /sys/time.h Structures						*/
/*									*/

struct timeval				/* Struct returned by gettimeofday()*/
{					/*    system call		    */
    long	tv_sec;			/* seconds			    */
    long	tv_usec;		/* microseconds			    */
};

struct timezone
{
    int	tz_minuteswest;			/* minutes west of Greenwich	    */
    int	tz_dsttime;			/* type of dst correction	    */
};					/* dst not implemented (always 0)   */
#endif /* !_sys_time_h && !__time_h */
#endif /* !__INCtimesh */
#endif /* VXWORKS */

#endif /* INCtod_time */

/* file: tod_time.h */
