/************************************************************************/
/* File: tod_user.h							*/
/*									*/
/* This is a modified version of time.h written to use specific		*/
/* Time-Of-Day devices that are implemented with the FSCC PC4 (DS1386),	*/
/* FSCC PC3 (DS1286), MVME167 MK48T08					*/
/*									*/

/*
SCCS release:
@(#) tod_user.h 1.4 Delta: 93/12/22 11:37:41 Extraction: 94/01/11 14:51:48 @(#)
*/

#ifndef INCtod_user
#define INCtod_user

/************************************************************************/
/*									*/
/* Type Definitions and Structures					*/
/*									*/

#ifndef VX_TOOLS_NVRAM_TZDATE
#define TOD_NVRAM_OFFSET 512		/* starting address in NVRAM */
#else
#define TOD_NVRAM_OFFSET VX_TOOLS_NVRAM_TZDATE
#endif

#define TOD_NVRAM_SIZE 50		/* 50 bytes of Zone data */
#define TOD_WRNVRAM 0			/* Write */
#define TOD_RDNVRAM 1			/* read */

#ifdef DS1386
#define TOD_MAXNVRAM 8192
#endif
#ifdef DS1286
#define TOD_MAXNVRAM 50
#endif
#ifdef MK48T02
#define TOD_MAXNVRAM 2048
#endif
#ifdef MK48T08
#define TOD_MAXNVRAM 8192
#endif

#ifndef TOD_MAXNVRAM
#define TOD_MAXNVRAM 0
#endif

struct tzrules {
	int	month;
	int	day;
	int	hour;
	int	minute;
	int	dayofweek;
};

#endif /* INCtod_user */

/* file: tod_user.h */

/************************************************************************/
