/************************************************************************/
/*									*/
/*	Computing Department						*/
/*	P.O. BOX 500							*/
/*	Fermilab, Batavia, Il 60510, U.S.A.				*/
/*									*/
/* File: vx_tools.h					April 8, 1993	*/
/*									*/
/* This file contains common definitions that may be used on the	*/
/* various modules.							*/
/*									*/
/*
SCCS release:
@(#) vx_tools.h 1.4 Delta: 93/06/10 15:03:02 Extraction: 93/06/10 15:21:50 @(#)
*/
/* History:
	Apr 08, 1993 swk Creation
	Jun 01, 1993 swk add Auto stack check definitions
*/


#ifndef INCvx_toolsh
#define INCvx_toolsh

/************************************************************************/
/*									*/
/* Get Hardware Definitions for the various modules should they exist	*/
/*									*/

#if	defined(fscc) || defined(pc3) || defined(pc4) || defined(pc4a)
#include "fscc.h"		/* Hardware definitions for FSCC PC4 */
#elif	defined(frc)
#include "frc.h"		/* Hardware definitions for FRC */
#elif	defined(mv147)
#include "mv147.h"		/* Hardware definitions for MVME147 */
#elif	defined(mv167)
#include "mv167.h"		/* Hardware definitions for MVME167 */
#elif	defined(mv162)
#include "mv162.h"		/* Hardware definitions for MVME162 */
#elif	defined(rs33)
#include "rs33.h"		/* Hardware definitions for Radstone33 */
#elif	defined(rs41)
#include "rs41.h"		/* Hardware definitions for Radstone41 */
#elif	defined(tp41)
#include "tp41.h"		/* Hardware definitions for tadpole41 */
#elif	defined(all)
#include "configAll.h"		/* Generic Hardware definitions */
#endif

#include "vxt.h"		/* Some prototypes */
/************************************************************************/
/*									*/
/* Time-Of-Day Definitions NVRAM	(DS1386=8k, MK48T08=8k,		*/
/*					 MK48T02=2k)			*/
/*									*/
/* NVRAM Allocation:			(in bytes)			*/
/* 									*/
/*					sysNvRamGet()/sysNvRamSet()	*/
/*									*/
/* 		offset [0 - 255]	VxWorks	Boot configuration	*/
/*		offset [512 - 767]	Time-Of-Day tzRules data	*/
/*		offset [1024-?]		future use			*/
/*									*/

#define VX_TOOLS_NVRAM_BASE	256	/* First 256 bytes used by VXWORKS */

#define VX_TOOLS_NVRAM_TZDATE	VX_TOOLS_NVRAM_BASE+256

/************************************************************************/
/*									*/
/* Auto Stack Checking Definitions for "vx_tools.c"			*/
/*									*/
/*									*/

/* 
   Commented out! Let's assume a low level check for underflow exists
   #define AUTOSTACKUNDERFLOW 1
*/

#define AUTOSTK_NORMAL 0	/* NORMAL all hooks removed */
#define AUTOSTK_SWITCH 1	/* Mask bit check on task switch */
#define AUTOSTK_DELETE 2	/* Mask bit check on task delete */
#define AUTOSTK_CREATE 4	/* Mask bit check on task create */

#endif /* INCvx_toolsh */

/* file: vx_tools.h */
