'\"
'\" Copyright 1989 Regents of the University of California
'\" Permission to use, copy, modify, and distribute this
'\" documentation for any purpose and without fee is hereby
'\" granted, provided that this notice appears in all copies.
'\" The University of California makes no representations about
'\" the suitability of this material for any purpose.  It is
'\" provided "as is" without express or implied warranty.
'\" 
'\" $Header: /usr/products/IRIX/olsrcvs/v1_1/src/vx_tools/man/vx_tools.man,v 1.1 1995/03/24 21:10:06 vittone Exp $ SPRITE (Berkeley)
'\" 
.\" The definitions below are for supplemental macros used in Sprite
.\" manual entries.
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'	# Heading for Sprite man pages
.de HS
.if '\\$2'cmds'       .TH \\$1 1 \\$3 \\$4
.if '\\$2'lib'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tcl'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tk'         .TH \\$1 3 \\$3 \\$4
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'	# BS - start boxed text
'	# ^y = starting y location
'	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'	# VS - start vertical sidebar
'	# ^Y = starting y location
'	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'	# Special macro to handle page bottom:  finish off current
'	# box/sidebar if in box/sidebar mode, then invoked standard
'	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'	# DS - begin display
.de DS
.RS
.nf
.sp
..
'	# DE - end display
.de DE
.fi
.RE
.sp .5
..
.HS vx_tools
.BS
.SH NAME
vx_tools
.BE
#
.SH DESCRIPTION
.PP
.PP
\fBvx_tools\fR version \fB2.0\fR and greater.

The vx_tools package is a conglomeration of useful code to supplement
the VxWorks package. This package provide generic and target specific
code that resides in a common user package. vx_tools depends on vxworks
product. The software has been implemented for the following boards:

.PP
	fscc  mv167  mv147  frc

Starting with \fBversion 2.0\fR, the product has been completly restructured.
The product is declared to the UPS databases with the flavor of VxWorks.

Three versions of VxWorks are currently supported :

.PP
	v5.1.1  SunOS and IRIX
.PP
	v5.0.2b SunOS
.PP
	v5.0.5  IRIX

.PP

On the SunOS, to manage the co-existence of both versions two separate databases
have been defined. 
.PP
To setup the desired version of vx_tools product, the user needs first to do 
the following:

.PP
  setup vxprods      To setup vxworks version 5.1.1 on either 
                     IRIX or SunOS

.PP
  setup -o vxprods   To setup vxworks version 5.0.2b on Sun and 
                     5.0.5 on IRIX

.PP

The source code is now managed with cvs instead of sccs.
The product structure now follows the standard conventions :

.PP

$VX_TOOLS_DIR/version/
.PP
			src/
.PP
			include/
.PP
			bin/
.PP
			objects/
.PP
			lib/
.PP
			doc/
.PP
			ups/
.PP
			ups/toman
.PP
			ups/tonews

.PP

All the sources are in the src area and the object files and libraries reflect
the board they are built for in their names according to the OLS standards.

.PP
To build the software , the premake-make method is used.
To build the software for the fscc, the user must also setup vx_fscc
and to build the software for the frc, setup vx_frc.
.PP
Many targets are available when invoking premake:
in same cases premake takes only one mandatory argument, in others, two
arguments:
.PP

One mandatory  target:	

.PP	
    premake doc         To build documentation

.PP
    premake clean       To remove ALL objects and libraries

.PP
    premake all		To build everything for the specific
                        vxworks version-platform:
.PP
                        5.1.1  all for fscc, mv167 and mv147
.PP
                        5.0.2b all for fscc mv167 and mv147
.PP
                        5.0.5  all for frc				
.PP

    premake install	This is used after everything is built 
.PP
                        and it is typically used to cut 
.PP
                        a version; all the files are copied from 
.PP
                        the user working area to the one specified 
.PP
                        by the environmental variable VX_TOOLS_DIR
.PP
                        that need to be set prior to installing.

.PP

Two mandatory  targets:

.PP
   premake target bdtype

.PP	
   valid bdtype:          mv167 mv147 fscc frc

   premake tod <bdtype>   To build time of the day library and
                          test for the specific board <bdtype>

   premake gen <bdtype>   To build a generic library

.PP
   premake sup <bdtype>   To build a support lib for mv167 or mv147.

.PP
   premake dvx <bdtype>   To build the dvx task variables package

   premake systools <bdtype> 

.PP
   premake lib_<bdtype> <bdtype>  This is to build a comprehensive 
.PP
                                  library for the specific board.

.PP
   premake all_<bdtype> <bdtype>  This is to build everything of 
                                  the above for the specific board.

.PP

One optional target to follow at the end:
                  <debug>   <optimize>


For the full documentation on vx_tools, the user should refer to pn440
available in the doc area and accessible through WWW in the DART page.

.PP
