{
   // Client program which open (close) file at SOR (EOR) automaticly send by 
   // the server. Client request events from the server and analyzes them.
   // The results (histogramms) will be 
   // filled into a shared memory file. The nr of the processed event
   // will be histogrammed for monitoring purpose. 
   // At the moment the programm stops after one run (this will be changed 
   //  in future)

   gROOT->Reset();

// initialize the online monitoring process
// ******************************************
  TPhDetector *det;  
  if(det) det->DeleteInstance();
  char FileName[256];
  sprintf(FileName,"%s/init/test/Detector.root", 
	  gSystem->Getenv("PHATHOME"));
  TFile f(FileName);
  det = (TPhDetector*) f.Get("LatestGeometry");
  f.Close();

  // create histos for all si sensors
//*************************************
  TPhOnSensorContainer *container = new TPhOnSensorContainer("Sensors");
  TPhSubDetector *sub = det->GetSubDetector("Octagon");
  container->Init(sub);
  //container->Init();

  // open  canvas for histos
  TCanvas *hcan =  new TCanvas("client","client monitor histos");

   // Open connection to server
   TSocket *csock = new TSocket("phobosx.chm.bnl.gov", 7002);

   // initialize the client status 
   
   Int_t status_flag = 0;
   Int_t leftover_flag = 0;
   printf("initializing the client, status_flag = %d\n",status_flag);
   TStopwatch *timer = new TStopwatch();
   Int_t n=0;
   Char_t classtype[256];
   TMessage *mess; 
   Int_t fRecv;
   Char_t cstr[256];

// test with TPhRawHitTest
   TPhRawHitTest *rawhit;
   Int_t ibuff[1000];
   rawhit = new TPhRawHitTest(ibuff, 1000);
   rawhit->Print();

// tell server to send SOR data to the client
   csock->Send("wait_for_SOR");
   printf("message 'wait_for_SOR' send\n");
   // endless loop: client-server-connection
   //*****************************************************
   while (1) {
      fRecv= csock->Recv(mess);
      printf("received %d bytes\n",fRecv);
      if(fRecv<0)
	{
	  printf("error message received, error code %d -return\n ",fRecv);
	  return;
	} 
      else //****** to if(fRecv<0) 
	{
	  printf("received message type %d, size %d\n",mess->What(),fRecv);
	  if (mess->What() != kMESS_OBJECT) 
	    {
	      printf("ERROR in onclient: unexpected message, received %d\n",
		     mess->What());   
	      return;
	    }
	  else //*** if (mess->What() != kMESS_OBJECT) 
	    {	  
	      printf("Class name:%s\n", mess->GetClass()->GetName());	    
	      sprintf(classtype,"%s", mess->GetClass()->GetName());	    
	      // check whether it's an event
	      if(strcmp(classtype,"TPhEvent"))
		{
		  printf("got object of type %s expect TPhEvent\n", classtype);
		  printf("ask for new event\n");
		  csock->Send("Waiting");
		}
	      TPhEvent *event = (TPhEvent *)mess->ReadObject(mess->GetClass());
	      timer->Stop();
	      sprintf(cstr,"%s",event->GetName());
	      printf("client got event name %s, size %d\n",cstr,fRecv);
              event->Print();  
	      // SOR case: 
	      // *********************************************************
	      if (!strcmp(cstr, "SOR")) 
		{
		  if(status_flag == 0) 
		    {
		      status_flag = 1;
		      printf("SOR: change status flag from 0 to 1\n");
		    }
		  else 
		    { 
		      printf("ERROR in client: wrong status for SOR\n");
		      return;
		    }	    
		  // Create the histogram of the client process
		  //** TH1F *monhisto = 
		  //** new TH1F("mchit","Nr of mc hits in buffer",100,0,50000);
		  printf("created monitoring histogram\n");
		  // tell server that client is ready to accept events
		  csock->Send("waiting");                // send message 
		  printf("message 'waiting' send\n");
		  // start time measurement
		  timer->Start(kTRUE);
		} 
	      // EOR case 
	      // *********************************************************
	      else if (!strcmp(cstr, "EOR"))
		{
		  timer->Stop();
		  printf("%d events received, real time/ev %f, cpu time/ev %f\n",n, 
			 timer->RealTime()/n, timer->CpuTime()/n);
		  if (status_flag == 1)
		    {
		      printf("reset status flag\n");
		      status_flag = 0;
		    }
		  else 
		    printf("ERROR in onclient: wrong status for EOR\n");
		  monhisto->DrawCopy();
		  // Close the socket 
		  csock->Close();
		  printf("close socket\n");
		  break;
		}
	      else 
		{
		  //*********************************************************
		  // case: receive normal TPhEvent
		  //**************************************************
		  //	    n++;
		  timer->Stop();
		  if (status_flag != 1)
		    {			
		      // take care of leftover messages if the connection 
		      // was broken previously
		      if(leftover_flag == 0) 
			{
			  leftover_flag = 1;
		          printf("client: set leftover_flag to %d and delete event %s\n",
                          leftover_flag,event->GetName());
			  delete event;
			}
		      else
			{
			  printf
                          ("ERROR in client:wrong status to receive event!\n");
			  return;
			}
		    }	  
		  else
		    {
		      Int_t nevent = event->GetNEvent();
		      printf("got event nr %d, with the following content\n",nevent);
		      event->ls("d");
		      // finished with this event; request new one
		      csock->Send("waiting");                // send message
		      delete event;
		      //deb//printf("send message 'waiting'\n");
		      timer->Start(kFALSE);
		    }
		}// end of if(!strcmp(cstr,"SOR")... else()
	      // clean up the process 
	      n++;
	      delete mess;
	      //deb//printf("delete message\n");
	      //deb//printf("******************************\n");
	    }
	}
   } // end of while(1)

}
