/////////1/////////2/////////3/////////4/////////5/////////6/////////7//////////
//
// phatdaq control macro. It sends commands to phatdaq using TCP socket opened
// in phatonl_init.C macro. The command structure is defined in daqmessages.h.
// I had difficulties of including thhis file here and therefore hardcoded it 
// inside the macro 
//
int runcontrol_command(int command = 0, int argument = 0)
{
  cmd.bytes   = sizeof(struct DAQMSG);
  cmd.command = command;
  cmd.data[0] = argument;
  Int_t bytes;
  Int_t size;
  Int_t status_size = 24;
  Double_t tnew = 0;
 
  sock->SendRaw(&cmd, cmd.bytes, 0);
  size = sizeof(struct DAQMSG);
  if (cmd.command == 16)
    size += status_size*4;

  bytes = sock->RecvRaw(response, size , 0);
  if ( bytes < 0 )
    {
      cout << "Socket read error. Socket will be closed."<<bytes<<endl;
      sock->Close();
      return bytes;
    }
  if (bytes == 0)
    {
      cout << "Broken pipe. Socket will be closed."<<endl;
      sock->Close();
      return -1;
    }

  if(response->data[0] != 0)
    cout << "Command failed, code =" << response.data[0] << endl;

  cout << "response " << bytes << ", "<< response->command << endl; 

/////////1/////////2/////////3/////////4/////////5/////////6/////////7//////////
  //  Status command
  Int_t *iptr = response->data;
  Int_t *status = iptr+1;
  if(response->command == (2*8 + 1))
    {
      tnew = timer.RealTime();
      /*for(Int_t i=0; i < status_size; i++)
	{
	  if((i % 8) == 0)
	    printf("\n%4.4x:",i*4);
	  printf(" %8.8x",*iptr++);
	}
	*/
      deltat = tnew - deltat;

      time_t cur_time = time(0);
      printf("%s",ctime(&cur_time));
      if(status[12] == 0)
	printf("Run have not been started\n");
      else
	{
	  printf("Run%d  started %s",status[0], ctime(&(status[12])));
	  if(status[13] > status[12])
	    {
	      printf("Run%d finished %s",status[0], ctime(&(status[13])));
	      cur_time = status[13];
	    }
	  printf("Duration = %d sec\n",cur_time - status[12]);
	}
      printf(
          "%d events, %6.1f MB, %6.1f Ev/Sec, %7.1f KB/sec, raw=%7.1f KB/sec\n",
	    status[6], (double)status[1]/1000000.,
	     (double)(status[6] - run_events )/deltat,
	     (double)(status[1] - run_bytes)/deltat/1000.,
	     (double)(status[2] - run_recv_bytes)/deltat/1000.);
      printf("%d errors, %d lost events, %d transfers, %d messages\n",
	     status[7], status[8], status[4], status[5]);
      printf("%d analyzed events. Control = %d, \n",status[11],status[9]);
      run_bytes = status[1];
      run_recv_bytes = status[2];
      run_events = status[6];
      deltat=tnew;
      timer.Continue();
    }

  cmd.seqn++;
  return cmd.seqn;
}
