#include <stdio.h>

#ifdef VXWORKS

#include "vxt.h"

int optind = 0;
int opterr = 1;

char *optarg = 0;

/*****************************************
* This function will perform the same function as
* the UNIX call.
*******************************************/
int getopt(argc, argv, optstring)
int argc;
char *argv[];
char optstring[];
{
    int i;
    char option;

    if (optind >= argc)
	return (-1);

    /* Clear the return parameter */
    optarg = NULL;

    /* Check for an option present, i.e. starts with a hypen */
  if (argv[optind][0] != '-')
	return (-1);

    /* Pick up first letter of option (rest of option is ignored) */
    option = argv[optind][1];

    /* Double hypen means end of options */
    if (option == '-')
    {
	optind++;
	return (-1);
    }

    /* Search for a matching option */
    for (i=0; optstring[i] != 0; i++)
    {
	if (option == optstring[i])
	    break;
    }

    /* No valid option found */
    if (optstring[i] == 0)
    {
	if (opterr)
	    fprintf(stderr, "%s: Illegal option `%s'\r\n",
		argv[0], argv[optind]);
	option = '?';
    }

    /* Option is OK - Check for a parameter */
    else
    {
	/* Parameter required? */
		if (optstring[i+1] == ':')
	{
	    if ( (optind+1 < argc) && (argv[optind+1][0] != '-') )
	    {
		optind++;
		optarg = argv[optind];
	    }
	    else
	    {
		if (opterr)
		    fprintf(stderr,"%s: Argument required for `%s'\r\n",
			argv[0], argv[optind]);
	    }
	}
    }

    /* Bump counter to next argument */
    optind++;

    /* Return the letter we found */
    return (option);

}
/************************************
*
* This function is only for VXWORKS boards.
* It will build the argc and argv variables simular to
* the UNIX system.
***************************************/
void build_argv(int *argc, char *argv[],char *str)
{
int i = 0;
int place = 0;
char *str_holder;


	str_holder = calloc(10);

/* read past spaces at beginning */
while(*str == ' ')str++;

while(*str != '\0'){
	if(*str == ' '){
		str_holder[i] = '\0';
		argv[place] = str_holder;
		str_holder = calloc(10);
		place++;
		i = 0;
		while(*str == ' ')str++;
		}
	else{
		str_holder[i++] = *str;
		str++;
		}
}
	argv[place] = str_holder;
	*argc = place+1;
}
#endif		/* VxWorks */
