/************************************************************************/
/*									*/
/* Examples taken from pn440.tex document				*/
/*									*/
/* File: vme_example.c							*/
/*									*/
/* Modifications:							*/
/* 23dec93	das	   added prototypes, VxWorks 5.1 updates	*/
/* 13nov95      m.vittone  chnaged names of includes files for the sup  */ 
/************************************************************************/

#include <vxWorks.h>
#include <msgQLib.h>
#include <semLib.h>
#include <taskLib.h>
#include <logLib.h>
#include "mvsup.h"
#include "mvsup_prototypes.h"

/************************************************************************/
/* PROTOTYPES								*/
/*									*/
void initialization(void);
void clock1_interrupt_handler( MSG_Q_ID msg_q );
void clock1_interrupt_task( MSG_Q_ID msg_q );
void example(void);

/************************************************************************/
/* ROUTINE INITIALIZATION						*/
/*									*/
void initialization(void)
{
    MSG_Q_ID    msg_q;
    /*void    clock1_interrupt_handler(),clock1_interrupt_task();*/

    msg_q = msgQCreate(100,4,MSG_Q_PRIORITY );
    clk1Disable();				/* just for good measure */
    clk1Connect((FUNCPTR)clock1_interrupt_handler, (int)msg_q);
    clk1RateSet(1); /* one tick per second */

    taskSpawn("tClk1",200,0,2000,(FUNCPTR)clock1_interrupt_task, (int)msg_q,
		0,0,0,0,0,0,0,0,0);

    clk1Enable();
}

/************************************************************************/
/* ROUTINE CLOCK1_INTERRUPT_HANDLER					*/
/*									*/
void clock1_interrupt_handler( MSG_Q_ID msg_q )
{
    msgQSend(msg_q,"1234",4,NO_WAIT,MSG_PRI_NORMAL);
}

/************************************************************************/
/* ROUTINE CLOCK1_INTERRUPT_TASK					*/
/*									*/
void clock1_interrupt_task( MSG_Q_ID msg_q )
{
    char    msg_buf[4];

    while(1)
    {
        msgQReceive(msg_q,msg_buf,4,WAIT_FOREVER);

        /* more task code could go here */

        logMsg("receive interrupt",0,0,0,0,0,0);
    }
}

/************************************************************************/
/* ROUTINE EXAMPLE							*/
/*									*/
void example(void)
{
    unsigned int t1;
    int i;

    clk2Stop();
    clk2Start();

    t1=clk2Read;
	
    /* place code to be timed here between clk2Read and clk2Diff(t1) */
    for (i = 0; i < 1000000; i++);

    logMsg("time in usec for stuff is %u\n",clk2Diff(t1),0,0,0,0,0);
}


/* file: vme_example.c */
