/************************************************************************/
/*									*/
/* File: tod_vector.c	ROUTINES available for xxx.o files		*/
/*									*/

/*
SCCS release:
@(#) tod_vector.c 1.3 Delta: 93/12/22 11:34:54 Extraction: 94/01/11 15:09:14 @(#)
*/

#include <vxWorks.h>                    /* VxWorks types		*/

#include <time.h>

#include "tod_time.h"
#include "tod_prototypes.h"

/************************************************************************/
/*									*/
/* PROTOTYPES								*/
/*									*/
#ifndef INCtod_prototypesh
extern void	tod_device_id(void);
extern void	tod_device_on(void);
extern void	tod_device_off(void);
extern time_t	tod_device_read(struct tm *tp);
extern time_t	tod_read(void);
extern void	tod_device_write(const struct tm *tp);
extern void	tod_write(time_t timer);


extern INT32	tod_daysinmonth(INT32 year, INT32 month);
extern char	*tod_asciiday(INT32 day);
extern char 	*tod_asciimonth(INT32 mo);
extern INT32 	tod_julday(INT32 yr, INT32 mo, INT32 day);
extern INT32	tod_ep_days(int year, int yday);
#endif /* INCtod_prototypesh */

/*void	time();*/
/*void	gmtime();*/
/*void	localtime();*/
/*void	stime();*/
/*void	asctime();*/
/*void	ctime();*/
/*void	get_tm();*/
/*void	settimeofday();*/
/*void	gettimeofday();*/
/*void	mktime();*/
/*void	date();*/

#ifndef INCtod_prototypesh
extern int	tod_initial(void);
extern int	tod_show_tzrules(void);
extern int	tod_get_tzrules(void);
extern int 	tod_set_tzrules(INT32 tz_hhmm, 
				INT32 atz_hhmm,
                        	INT32 atzBegin_mmddhhmmd,
                        	INT32 atzEnd_mmddhhmmd,
                        	char *tz_name, 
				char *atz_name);
extern int 	tod_setgmt(INT32 yymmdd, INT32 hhmmss);
extern int 	tod_setlocal(INT32 yymmdd, INT32 hhmmss);
#endif /* INCtod_prototypesh */

/************************************************************************/
/* ROUTINE TOD_VECTOR		What's available			*/
/*									*/

int tod_vector(void)
{

	tod_device_id();
	tod_device_on();
	tod_device_off();
	tod_device_read((struct tm *)0);
	tod_read();
	tod_device_write((const struct tm *)0);
	tod_write((time_t)0);


	tod_daysinmonth((INT32)0, (INT32)0);
	tod_asciiday((INT32)0);
	tod_asciimonth((INT32)0);
	tod_julday((INT32)0, (INT32)0, (INT32)0);
	tod_ep_days((int)0, (int)0);


	time((time_t)0);
	gmtime((const time_t *)0);
	localtime((const time_t *)0);
	stime((long *)0);
	asctime((const struct tm *)0);
	ctime((const time_t *)0);
	get_tm((const time_t)0, (struct tm *)0);
	settimeofday((struct timeval *)0, (struct timezone *)0);
	gettimeofday((struct timeval *)0, (struct timezone *)0);
	mktime((struct tm *)0);
	date();


	tod_initial();
	tod_show_tzrules();
	tod_get_tzrules();
	tod_set_tzrules((INT32)0, (INT32)0, (INT32)0, (INT32)0, (char *)0, (char *)0);

	tod_setgmt((INT32)0, (INT32)0);
	tod_setlocal((INT32)0, (INT32)0);

	return (0);
} /* tod_vector */

/* file: tod_vector.c */
