/*
**	MODIFICATIONS
**	17dec93	das	5.1 changes, added (const char *) cast to first bcopy
**			arg., ioctl 3rd arg was (void *), now (int)
**
**/

/* DO NOT USE OPTIMIZE -- asm( ) is used! */

#include "vxWorks.h"
#include "types.h"
#include "ioLib.h"
#include "taskLib.h"

#include "stdioLib.h"

#define	TRACE_DEFINE_GLOBALS
#include "trace.h"
#undef	TRACE_DEFINE_GLOBALS



int getSR()
{
    __asm__(".word 0x40c0; " );	/* move into d0 (standard c return reg) */
}



void setSR(/*sr*/)
    /*unsigned short sr; comment out to produce better code*/
{
    __asm__(".word 0x46ee, 0x000a; " );
}

int disableInt()	/* set int mask to level 7 */
{
    __asm__( ".word 0x40c0; movew d0,d1; oriw #0x0700,d1; .word 0x46c1; " );
    /* returns sr (in d0) */
}

#define enableInt(sr)	setSR(sr)


/******************************************
 *   trcMsgTsk
 *  9 characters for the name -- any more messes up the output of the vxworks
 *  "spy" command.
 */

void trcMsgTsk()
{
        ENTRY_T	b;
	char	buf[80];

    traceMsgQ = msgQCreate(TRACE_TASK_MSG_Q_SIZE,sizeof(b),MSG_Q_FIFO);
    strcpy(buf,"%10u %7x%s");

    while(1)
    {
        msgQReceive(traceMsgQ,(char *)&b,sizeof(b),WAIT_FOREVER);
	sprintf(&buf[10],"%s\n",b.msg);
        printf(buf,b.time,b.tnum,traceLvlStr[b.lvl],b.params);
    }
}


/******************************************************************************
 *  traceInit
 *  
 *  	This routine relies on the trace_key_variables structure memory is
 *  initally all zeros (memory is cleared when computer board is reset and
 *  then this module is loaded).
 *  
 */

int traceInit(circ_que_entries, max_tasks, traceclk)
    int			circ_que_entries, max_tasks;
    unsigned int	traceclk;
{
	VOID		*tmp, *sav;
	int		i;
extern	void		traceTaskCreateHook();
extern	void		traceTaskDeleteHook();
	unsigned short	sr;


    trace_.traceClk = (unsigned int *)traceclk;
    if ( max_tasks == 0 ) max_tasks = DEFAULT_MAX_TASKS;
    max_tasks++;	/* MAKE ROOM FOR SPECIAL INDEX 0 */
    if (max_tasks>trace_.traceMaxTasks)	/* can only increase */
    {
	/* calloc space is "initialized to zeros" */
	if ( (tmp=(VOID *)calloc(max_tasks,4*3))==0 ) return(-1);/* task id and trace lvl */
	sav = (VOID *)trace_.traceLevel;
	sr = disableInt();
        if (trace_.traceLevel !=0 )
	{
	    bcopy((const char *)trace_.traceLevel,tmp,trace_.traceMaxTasks*4);
	    bcopy((const char *)trace_.traceTid,tmp+max_tasks,trace_.traceMaxTasks*4);
	}
	trace_.traceLevel = tmp;
	trace_.traceTid = (unsigned int *)tmp+max_tasks;	/* go 1/3 way */
	trace_.traceName = (char **)tmp+(2*max_tasks);	/* go 2/3 way */
	trace_.traceMaxTasks = max_tasks;
	enableInt(sr);
	if (sav!=0)  cfree(sav);
    }
printf("traceLevel array at 0x%08.8x, traceTid array at 0x%08.8x\n",trace_.traceLevel,trace_.traceTid);

    if (circ_que_entries==0) circ_que_entries=DEFAULT_NUM_ENTRIES;


printf("sizeof(ENTRY_T)=%d\n",sizeof(ENTRY_T));
    sav=(VOID *)trace_.traceCircQueBegin;
    tmp=sav;
    /* check for size change */
    if ( circ_que_entries != (trace_.traceCircQueEnd-trace_.traceCircQueBegin) )
    {   /* size change - calloc a new buffer */
printf("callocing %d bytes\n", circ_que_entries * sizeof(ENTRY_T));
	if ( (tmp=(VOID *)calloc(circ_que_entries,sizeof(ENTRY_T)))==0 )
	    return(-2);
    }

    sr=disableInt();
    trace_.traceCircQueBegin = (ENTRY_T *)tmp;
    trace_.traceCircQueHead = trace_.traceCircQueTail = trace_.traceCircQueBegin;
    trace_.traceCircQueEnd = trace_.traceCircQueBegin+circ_que_entries;
    trace_.traceCircQueEmpty = 1;
    trace_.traceCircQueFull = 0;
    enableInt(sr);

printf("traceCircQueBegin=0x%08.8x, traceCircQueEnd=0x%08.8x\n",trace_.traceCircQueBegin,trace_.traceCircQueEnd);
    if ( (sav!=(VOID *)trace_.traceCircQueBegin) && (sav!=0) )
    {
printf("cfreeing\n");
	cfree(sav);
    }

    if ( traceInited==0 )
    {
        taskSpawn("tTrace",TRACE_TASK_PRIO,VX_FP_TASK|VX_STDIO,2000,trcMsgTsk);
	for(i=0;i<32;i++)
	    traceLvlStr[i]=(31-i)+"                                ";
	strcpy(trace_.traceBlockMarker,TFS);
	strcat(trace_.traceBlockMarker,TSS);
	taskCreateHookAdd(traceTaskCreateHook);
	taskDeleteHookAdd(traceTaskDeleteHook);
	traceInited = 1;
    }
}



void traceTaskCreateHook(id)
    WIND_TCB *id;
{
	int	i;

    taskVarAdd(id,&traceTask);
    for(i=1;i<trace_.traceMaxTasks;i++)	/* don't check index 0 - it's special */
    {
	if(trace_.traceTid[i]==0)	/* FIND FIRST AVAILABLE SPOT */
	{
	    ++trace_.traceNumTasks;
	    trace_.traceTid[i]=(unsigned int)id;
	    trace_.traceLevel[i]=trace_.traceInitialLvl;
	    taskVarSet(id,&traceTask,i);
	    break;
	}
    }
    if (i==trace_.traceMaxTasks)
    {
	trace_.traceTid[0] = -1;	/* THIS FLAGS THE CONDITION THAT ... */
	taskVarSet(id,&traceTask,0);
    }
}



void traceProcCreate(name,procVar)
    char		*name;
    unsigned int	*procVar;
{
	int		i;
	unsigned short	sr;

    sr = disableInt();
    for(i=1;i<trace_.traceMaxTasks;i++)	/* don't check index 0 - it's special */
    {
	if(trace_.traceTid[i]==0)	/* FIND FIRST AVAILABLE SPOT */
	{
	    ++trace_.traceNumTasks;
	    ++trace_.traceNotTasks;
	    trace_.traceTid[i]=(unsigned int)trace_.traceNotTasks;
	    trace_.traceLevel[i]=trace_.traceInitialLvl;
	    trace_.traceName[i] = name;
	    *procVar=(unsigned int)i;
	    break;
	}
    }
    if (i==trace_.traceMaxTasks)
    {
	trace_.traceTid[0] = -1;	/* THIS FLAGS THE CONDITION THAT ... */
	*procVar=(unsigned int)0;
    }
    enableInt(sr);
}



void traceTaskDeleteHook(id)
    WIND_TCB *id;
{
	int	i;

    for(i=1;i<trace_.traceMaxTasks;i++)	/* don't check index 0 - it's special */
    {
	if(trace_.traceTid[i]==(unsigned int)id)
	{
	    trace_.traceNumTasks--;
	    trace_.traceTid[i]=0;	/* MAKE SPOT AVAILABLE */
	    break;
	}
    }
}


/* don't use prototyping here because I'm doing something a little tricky */

void traceCircQuePut(  timestamp
		     , tracetask
		     , lvl
		     , msg_str
		     , params    )
    unsigned int	 timestamp,tracetask,lvl;
    char		*msg_str;
    USER_P_T		 params;
{
	unsigned short				sr;
	register struct trace_key_variables	*tt;
	register ENTRY_T			*th;


    /* DISABLE INTS */
    /* MUST SAVE/RESTORE SR B/C WE MIGHT (can't tell - just guess by examining
       stack frames) BE IN AN INT. HANDLER */
    sr = disableInt();

    tt = &trace_;
    th = tt->traceCircQueHead;
    th->time = timestamp;
    th->tnum = tracetask;
    th->lvl = lvl;
    th->msg = msg_str;
    th->params = params;

    th++;
    tt->traceCircQueHead = th;
    if ( th == tt->traceCircQueEnd ) tt->traceCircQueHead=tt->traceCircQueBegin;

    /* now tt->traceCircQueHead is at it's final value (may be diff than th) */
    if (tt->traceCircQueFull) tt->traceCircQueTail = tt->traceCircQueHead;
    else if(tt->traceCircQueHead==tt->traceCircQueTail) tt->traceCircQueFull=1;
    else tt->traceCircQueEmpty=0;

    enableInt(sr);
}



int traceShow(delta_time, lines)
    int		delta_time, lines;
{
	char		str_buf[200];
	ENTRY_T		*head,*tmp;
	int		time_sav,x;
	int		line_count=0,c2=0;


    /* ASSUME traceMode_ == 0 */

    if ( trace_.traceCircQueEmpty ) return(0);
    head = trace_.traceCircQueHead;
    tmp=head;
    tmp--;
    if(tmp==(trace_.traceCircQueBegin-1)) tmp=(trace_.traceCircQueEnd-1);
    time_sav=tmp->time;
    do
    {
	head--;
	if(head==(trace_.traceCircQueBegin-1)) head=(trace_.traceCircQueEnd-1);
	strcpy(str_buf,"%10u %7x %12s %s");
				/* SHOULD USE strncat! */
	strcat(str_buf,head->msg);
	strcat(str_buf,"\n");
	if (delta_time)
	{
	    x=abs(head->time - time_sav);
	    time_sav = head->time;
	}
	else x=abs(head->time - time_sav);
	printf(str_buf,x,trace_.traceTid[head->tnum]
		,trace_.traceTid[head->tnum]>trace_.traceMaxTasks
			? taskName(trace_.traceTid[head->tnum])
			: trace_.traceName[head->tnum]
		,traceLvlStr[head->lvl]
		,head->params 	/* reset of params */
		);
	++c2;
	if( isatty(STD_OUT) && (++line_count==16) )
	{
            printf("(%d) press q to quit, any other key to continue...",c2);
	    if (trace_get_press() == 'q') return(1);
	    line_count=0;
	}
    } while (head!=trace_.traceCircQueTail && (lines? --lines: 1));
    if (c2) printf("entries: %d\n",c2);
    return(1);
}
int trace_get_press()
{
        int     c, opts;

    opts = ioctl(0,FIOGETOPTIONS,0);
    ioctl(0, FIOSETOPTIONS, (int)(opts & ~OPT_LINE));
    c=getchar();
    ioctl(0, FIOSETOPTIONS, (int)(opts | OPT_LINE));
    if (c != '\n') putchar('\n');
    return(c);
}



void traceReset()		/* inited it again */
{
	unsigned short	sr;

    sr = disableInt();

    trace_.traceCircQueHead = trace_.traceCircQueTail = trace_.traceCircQueBegin;
    trace_.traceCircQueEmpty = 1;
    trace_.traceCircQueFull = 0;

    enableInt(sr);
}



void traceMode(x)
    int x;
{
    trace_.traceMode_ = x;
}



int traceModeGet()
{
    return( trace_.traceMode_ );
}



void traceLevelSet(level_ptr,l1,l2)
    unsigned int	*level_ptr;
    int			l1,l2;
{
	int	i;

    if(l1<l2)
    {	/* range */
	for(i=l1;i<=l2;i++)  *level_ptr |= (1<<i);
    }
    else
    {
	*level_ptr |= (1<<l1);
	*level_ptr |= (1<<l2);
    }
}


void traceLevelReset(level_ptr,l1,l2)
    unsigned int	*level_ptr;
    int			l1,l2;
{
	int	i;

    if(l1<l2)
    {	/* range */
	for(i=l1;i<=l2;i++)  *level_ptr &= ~(1<<i);
    }
    else
    {
	*level_ptr &= ~(1<<l1);
	*level_ptr &= ~(1<<l2);
    }
}



int traceOn(tid,l1,l2)
    unsigned int	tid,l1,l2;
{
	int	i;


    if( (l1>31) || (l2>31) ) return(-2);
    if(tid==0)
    {   traceLevelSet(&trace_.traceLevel[0],l1,l2);
    }
    else
    {   for(i=1;i<trace_.traceMaxTasks;i++) /* don't check index 0 - it's special */
	{   if(trace_.traceTid[i]==tid)
	    {   traceLevelSet(&trace_.traceLevel[i],l1,l2);
		break;
	    }
	}
	if(i==trace_.traceMaxTasks) return(-1);
    }
    return(1);
}



int traceOff(tid,l1,l2)
    unsigned int	tid,l1,l2;
{
	int	i;


    if( (l1>31) || (l2>31) ) return(-2);
    if(tid==0)
    {   traceLevelReset(&trace_.traceLevel[0],l1,l2);
    }
    else
    {   for(i=1;i<trace_.traceMaxTasks;i++) /* don't check index 0 - it's special */
	{   if(trace_.traceTid[i]==tid)
	    {   traceLevelReset(&trace_.traceLevel[i],l1,l2);
		break;
	    }
	}
	if(i==trace_.traceMaxTasks) return(-1);
    }
    return(1);
}



int traceGlobalOn(l1,l2)
    unsigned int	l1,l2;
{
	int	i;

    if( (l1>31) || (l2>31) ) return(-1);
    for(i=0;i<trace_.traceMaxTasks;i++)
    {   traceLevelSet(&trace_.traceLevel[i],l1,l2);
    }
    return(0);
}



int traceGlobalOff(l1,l2)
    unsigned int	l1,l2;
{
	int	i;

    if( (l1>31) || (l2>31) ) return(-1);
    for(i=0;i<trace_.traceMaxTasks;i++)
    {   traceLevelReset(&trace_.traceLevel[i],l1,l2);
    }
    return(0);
}



int traceInitialOn(l1,l2)
    unsigned int	l1,l2;
{
	int	i;

    if( (l1>31) || (l2>31) ) return(-1);
    traceLevelSet(&trace_.traceInitialLvl,l1,l2);
    return(0);
}



int traceInitialOff(l1,l2)
    unsigned int	l1,l2;
{
	int	i;

    if( (l1>31) || (l2>31) ) return(-1);
    traceLevelReset(&trace_.traceInitialLvl,l1,l2);
    return(0);
}



int traceTtyOn(l1,l2)
    unsigned int	l1,l2;
{
	int	i;

    if( (l1>31) || (l2>31) ) return(-1);
    traceLevelSet(&trace_.traceTtyLvl,l1,l2);
    return(0);
}



int traceTtyOff(l1,l2)
    unsigned int	l1,l2;
{
	int	i;

    if( (l1>31) || (l2>31) ) return(-1);
    traceLevelReset(&trace_.traceTtyLvl,l1,l2);
    return(0);
}



void traceInfo()
{
	int	i;

printf("traceCircQueBegin=0x%08.8x, traceCircQueEnd=0x%08.8x\n",trace_.traceCircQueBegin,trace_.traceCircQueEnd);
printf("traceCircQueEnd-traceCircQueBegin=%d\n",trace_.traceCircQueEnd-trace_.traceCircQueBegin);
printf("traceCircQueHead=0x%08.8x, traceCircQueTail=0x%08.8x\n",trace_.traceCircQueHead,trace_.traceCircQueTail);
printf("traceClk=0x%08.8x\n",trace_.traceClk);
    printf("\
num tasks: %5d        max tasks: %d\n\
num que entries: %5d  initialLvl: 0x%08.8x TtyLvl: 0x%08.8x\n\
trace mode: %d  0=off 1=cirQ   2=logMsg 3=cirQ/logMsg 4=USR       5=cirQ/USR\n\
   OLD MACRO - 0=off 1=printf 2=logMsg 3=circQue     4=traceTask\n"
	   ,trace_.traceNumTasks, trace_.traceMaxTasks-1	 /*don't count index 0*/
	   ,trace_.traceCircQueEnd-trace_.traceCircQueBegin
	   ,trace_.traceInitialLvl, trace_.traceTtyLvl
	   ,trace_.traceMode_ );


    printf("\
(trace)  #    id               name             level\n\
----------   ---------   ----------------   -----------\n");
    printf(  " %4d        0x%07x   %16s   0x%08x\n"
	   , 0, trace_.traceTid[0], "trace 0", trace_.traceLevel[0] );
    for(i=1;i<trace_.traceMaxTasks;i++)
    {
	if(trace_.traceTid[i]!=0)
	{
	    printf(" %4d        0x%07x   %16s   0x%08x\n",i,trace_.traceTid[i]
		,trace_.traceTid[i]>trace_.traceMaxTasks
			? taskName(trace_.traceTid[i])
			: trace_.traceName[i]
		,trace_.traceLevel[i]);
	}
    }
}



	struct trace_key_variables	*traceRemoteInfoBlockAddress = 0;
	unsigned int			traceRemoteSlaveBase;


int traceRemoteShow(delta_time,slave_base_addr,info_block_offset, num_entries, start_ent)
    int			delta_time;
    unsigned int	slave_base_addr, info_block_offset;
    int			num_entries; /* for io redirect (when > 16) */
    int			start_ent;
{
	char				str_buf[200];
	ENTRY_T				*head,*tmp;
	USER_P_T			l_params;
	int				time_sav,x;
	int				line_count=0,c2=0;
	int				i;
	unsigned int			*p, flag;
	char				*cp;
	struct trace_key_variables	r_;
	WIND_TCB			*tcb;
	char				*nam;
	char				l_p_strs[ITEMS_PER_ENTRY-4][100]; /*to limit strings */

    for(i=0;i<32;i++)
	traceLvlStr[i]=(31-i)+"                                ";

    if (( slave_base_addr!= 0) && (info_block_offset != 0))
    {   traceRemoteSlaveBase = slave_base_addr;
	traceRemoteInfoBlockAddress
		= (struct trace_key_variables *)(slave_base_addr
							+ info_block_offset);
	printf(" set traceRemoteInfoBlockAddress to 0x%08.8x\n"
		,traceRemoteInfoBlockAddress);
    }
    else if (    (traceRemoteInfoBlockAddress==0)
	      || (slave_base_addr!=0)  )
    {   if ( (traceRemoteInfoBlockAddress==0) && (slave_base_addr==0) )
	{   printf("can't find infoBlock without slave address\n");
	    return (-1);
	}
	traceRemoteSlaveBase = slave_base_addr;
	flag = *(unsigned int *)TFS;
	for (p=(unsigned int *)slave_base_addr;
		p < (unsigned int *)(slave_base_addr+0x2000000) /* 32 meg*/; p++)
	{   if (*p != flag) continue;
	    for ( cp=(char *)p; cp<(char *)p + 8; cp++ )
	    {   if ( (*cp == *TSS) || (*cp != *TFS) ) break;
	    }
	    if ( (cp == ((char *)p + 8)) || (*cp == *TFS) ) continue;
	    if ( strcmp(cp,TSS) != 0 ) continue;
	    traceRemoteInfoBlockAddress
			= (struct trace_key_variables *)(cp - 8);
	    break;
	}
	if ( p == (unsigned int *)(slave_base_addr+0x2000000) ) return (-1);
	printf( "offset = 0x%08x\n", cp-8-slave_base_addr );
    }

printf("traceRemoteInfoBlockAddress is 0x%08.8x\n",traceRemoteInfoBlockAddress);

    r_ = *traceRemoteInfoBlockAddress;
    (unsigned int)r_.traceTid += traceRemoteSlaveBase;
    (unsigned int)r_.traceLevel += traceRemoteSlaveBase;
    (unsigned int)r_.traceName += traceRemoteSlaveBase;
    (unsigned int)r_.traceCircQueHead += traceRemoteSlaveBase;
    (unsigned int)r_.traceCircQueTail += traceRemoteSlaveBase;
    (unsigned int)r_.traceCircQueBegin += traceRemoteSlaveBase;
    (unsigned int)r_.traceCircQueEnd += traceRemoteSlaveBase;


    /* ASSUME traceMode_ == 0 */

    if ( r_.traceCircQueEmpty ) return(0);
    head = r_.traceCircQueHead;

    /* skip past a specified number of entries */
    for (i=0; i<start_ent; i++)
    {   head--;
        if (head == r_.traceCircQueTail)
	    printf( "skipped to traceCircQueTail ... proceeding\n" );
	if(head==(r_.traceCircQueBegin-1)) head=(r_.traceCircQueEnd-1);
    }
	
    tmp=head;
    tmp--;
    if(tmp==(r_.traceCircQueBegin-1)) tmp=(r_.traceCircQueEnd-1);
    time_sav=tmp->time;
    do
    {   head--;
	if(head==(r_.traceCircQueBegin-1)) head=(r_.traceCircQueEnd-1);
	strcpy(str_buf,"%10u %7x %12s %s");
				/* SHOULD USE strncat! */
	strncat(str_buf,((unsigned int)head->msg)+traceRemoteSlaveBase,99);
	strcat(str_buf,"\n");
	l_params = head->params; /* copy all params over to local node */
	i = 0;	/* &&& hard coded - should be user param offset?? */
	cp = head->msg + traceRemoteSlaveBase;
	while ((*cp!='\0') && (i<2))
	{   if ((*cp=='%') && (*(cp - 1)!='\\'))
	    {   if (*(cp+1) == 's')
		{   strncpy( l_p_strs[i], l_params.p[i]+traceRemoteSlaveBase,99 );
		    l_params.p[i] = (unsigned int)l_p_strs[i];
		}
		i++;
	    }
	    cp++;
	}
	if (delta_time)
	{   x=abs(head->time - time_sav);
	    time_sav = head->time;
	}
	else x=abs(head->time - time_sav);

	if ( r_.traceTid[head->tnum] == 0 ) nam = "";
	else if ( r_.traceTid[head->tnum] > r_.traceMaxTasks)
	{   tcb = (WIND_TCB *)(r_.traceTid[head->tnum]+traceRemoteSlaveBase);
	    nam = (char *)tcb->name + traceRemoteSlaveBase;
	}
	else nam = r_.traceName[head->tnum] + traceRemoteSlaveBase;
	printf(str_buf,x,r_.traceTid[head->tnum]
		      /*,taskName(r_.traceTid[head->tnum])*/
		      ,nam
		      ,traceLvlStr[head->lvl] 
		      ,l_params 	/* reset of params */
			);
	++c2;
	if( isatty(STD_OUT) && (++line_count==16) )
	{   printf("(%d) press q to quit, any other key to continue...",c2);
	    if (trace_get_press() == 'q') return(1);
	    line_count=0;
	}
    } while ((head!=r_.traceCircQueTail) && (c2!=num_entries));
    if (c2) printf("entries: %d\n",c2);
    return(1);
}




int traceRemoteInfo(slave_base_addr,info_block_offset)
    unsigned int	slave_base_addr, info_block_offset;
{
	int	i;
	unsigned int			*p, flag;
	char				*cp,*nam;
	struct trace_key_variables	r_;
	WIND_TCB			*tcb;


    if (( slave_base_addr!= 0) && (info_block_offset != 0))
    {
	traceRemoteSlaveBase = slave_base_addr;
	traceRemoteInfoBlockAddress
		= (struct trace_key_variables *)(slave_base_addr
							+ info_block_offset);
	printf(" set traceRemoteInfoBlockAddress to 0x%08.8x\n"
		,traceRemoteInfoBlockAddress);
    }
    else if (    (traceRemoteInfoBlockAddress==0)
	      || (slave_base_addr!=0)  )
    {
	if ( (traceRemoteInfoBlockAddress==0) && (slave_base_addr==0) )
	{
	    printf("can't find infoBlock without slave address\n");
	    return (-1);
	}
	traceRemoteSlaveBase = slave_base_addr;
	flag = *(unsigned int *)TFS;
	for (p=(unsigned int *)slave_base_addr;
		p < (unsigned int *)(slave_base_addr+0x2000000) /* 32 meg*/; p++)
	{
	    if (*p != flag) continue;
	    for ( cp=(char *)p; cp<(char *)p + 8; cp++ )
	    {
		if ( (*cp == *TSS) || (*cp != *TFS) ) break;
	    }
	    if ( (cp == ((char *)p + 8)) || (*cp == *TFS) ) continue;
	    if ( strcmp(cp,TSS) != 0 ) continue;
	    traceRemoteInfoBlockAddress
			= (struct trace_key_variables *)(cp - 8);
	    break;
	}
	if ( p == (unsigned int *)(slave_base_addr+0x2000000) ) return (-1);
	printf( "offset = 0x%08x\n", cp-8-slave_base_addr );
    }

printf("traceRemoteInfoBlockAddress is 0x%08.8x\n",traceRemoteInfoBlockAddress);

    r_ = *traceRemoteInfoBlockAddress;

    (unsigned int)r_.traceTid += traceRemoteSlaveBase;
    (unsigned int)r_.traceLevel += traceRemoteSlaveBase;
    (unsigned int)r_.traceName += traceRemoteSlaveBase;


printf("traceCircQueBegin=0x%08.8x, traceCircQueEnd=0x%08.8x\n",r_.traceCircQueBegin,r_.traceCircQueEnd);
printf("traceCircQueEnd-traceCircQueBegin=%d\n",r_.traceCircQueEnd-r_.traceCircQueBegin);
printf("traceCircQueHead=0x%08.8x, traceCircQueTail=0x%08.8x\n",r_.traceCircQueHead,r_.traceCircQueTail);
printf("traceClk=0x%08.8x\n",r_.traceClk);
    printf("\
num tasks: %5d        max tasks: %d\n\
num que entries: %5d  initialLvl: 0x%08.8x TtyLvl: 0x%08.8x\n\
trace mode: %d  0=off 1=cirQ   2=logMsg 3=cirQ/logMsg 4=USR4      5=cirQ/USR\n\
    OLD MACRO - 0=off 1=printf 2=logMsg 3=circQue     4=traceTask\n"
	   ,r_.traceNumTasks, r_.traceMaxTasks-1	 /*don't count index 0*/
	   ,r_.traceCircQueEnd-r_.traceCircQueBegin
	   ,r_.traceInitialLvl, r_.traceTtyLvl
	   ,r_.traceMode_ );


    printf("\
(trace)  #    id               name             level\n\
----------   ---------   ----------------   -----------\n");
    printf(  " %4d        0x%07x   %16s   0x%08x\n"
	   , 0, r_.traceTid[0], "trace 0", r_.traceLevel[0]);
    for(i=1;i<r_.traceMaxTasks;i++)
    {
        if(r_.traceTid[i]!=0)
        {
            if ( r_.traceTid[i] == 0 ) nam = "";
            else if ( r_.traceTid[i] > r_.traceMaxTasks)
            {
		tcb = (WIND_TCB *)(r_.traceTid[i]+traceRemoteSlaveBase);
		nam = (char *)tcb->name + traceRemoteSlaveBase;
	    }
	    else nam = r_.traceName[i] + traceRemoteSlaveBase;
	    printf(" %4d        0x%07x   %16s   0x%08x\n",i,r_.traceTid[i]
	        ,nam
                ,r_.traceLevel[i]);
	}
    }
    return(0);
}



#include "trace.h"
#include "semLib.h"

void traceTest( int clk )
{
extern	void	t1_task();
extern	void	t2_task();
extern	void	t3_task();
extern	void	t4_task();

    if (clk==0)
    {   printf( "For the test, specified a clk reg other than 0.  For\n" );
	printf( "example, if you on a 167 with mv167sup.o loaded, you may\n" );
	printf( "wish to (make sure you've started clk1 via clk1Start and)\n" );
	printf( "retype traceTest as:\n" );
	printf( "     traceTest 0xfff40054\n" );
	return;
    }
    traceInit( 200, 10, clk );
    traceMode(3);
    traceGlobalOn(0,31);

    sp(t1_task);
    sp(t2_task);
    sp(t3_task);
/*    sp(t4_task);  FAST */
    testproc(0);

    traceGlobalOn(0,31);
}



void t1_task()
{
	int	t1,t2=0;
extern	void	handler();
	int i;
	SEM_ID sem;

    sem = semBCreate(SEM_Q_FIFO, SEM_EMPTY);
    sysAuxClkConnect(handler,sem);
    sysAuxClkRateSet(2);
    sysAuxClkEnable();

    while(1)
    {
	TRACE(1,"hello from t1_task",0,0);
    }
}

void handler(sem)
SEM_ID sem;
{
    TRACE(31,"INTERRUPT HANDLER sr=0x%04.4x",getSR(),0);
/*    logMsg("hello");*/		/* try logMsg after trace (mode 3) */
    semGive(sem);
}


void t2_task()
{

    while(1)
    {
	taskDelay(500);	/* should 1/2 second?? */
        testproc(2);
	t2_sub(1);
    }
}
void t2_sub(lvl)
    int lvl;
{
    lvl++;
    TRACE(lvl,"hello from T2 sub - sr is 0x%04.4x",getSR(),0);
}

void t3_task()
{

    while(1)
    {
	taskDelay(500);
        testproc(3);
	TRACE(1,"hello t3 sr is 0x%04.4x",getSR(),0);
    }
}

void t4_task()
{

    while(1)
    {
	/* SUPER FAST */
	TRACE(1,"hello t4 if this is enabled, it should be really fast",0,0);
    }
}

void testproc(int j)
{
	int	i;

    TRACEPROC("testproc");

    TRACEP(17,"hello: called with %d",j,0);
}
